﻿Imports System.Collections.ObjectModel

Public Class LogReader

    Public StopReading As Boolean = False
    Public dsLogFile As DataSet1
    Public m_MyForm As Form1

    ' Define a delegate type for the form's AddRowsToGrid
    ' method.
    Private Delegate Sub UpdateGridDelegateType(ByVal dr As Collection(Of DataSet1.LogRow))

    ' Declare a delegate variable to point
    ' to the form's AddRowsToGrid method.
    Private m_UpdateGridDelegate As UpdateGridDelegateType


    Public Sub New(ByVal myForm As Form1)
        dsLogFile = New DataSet1
        m_MyForm = myForm

        m_UpdateGridDelegate = New UpdateGridDelegateType(AddressOf m_MyForm.AddRowsToGrid)

    End Sub

    Public Sub StartReading()
        Dim t As New Threading.Thread(AddressOf BeginReading)
        t.IsBackground = True
        t.Start()
    End Sub

    Private Sub BeginReading()
        Dim cnt As Integer = 0
        Dim drColl As New Collection(Of DataSet1.LogRow)

        Do Until StopReading
            
            Dim r As DataSet1.LogRow = dsLogFile.Log.NewLogRow
            r._1LogText = Now.ToString

            drColl.Add(r)

            cnt += 1

            If cnt = 50 Then
                SyncLock m_MyForm
                    If m_MyForm.InvokeRequired() Then
                        m_MyForm.Invoke(m_UpdateGridDelegate, _
                            drColl)
                    End If

                End SyncLock
                        Threading.Thread.Sleep(2000)
                        Application.DoEvents()
                        cnt = 0
                        drColl.Clear()
                    End If
              
        Loop
    End Sub
End Class
